<script lang="ts" setup>
import AppContainer from "@/components/AppContainer.vue";
import { useQuery } from "vue-query";
import { groupsGetGroups } from "@/scripts/api-helper";
import GroupCard from "@/components/GroupCard.vue";
import { useRoute, useRouter } from "vue-router";
import PageHeader from "@/components/PageHeader.vue";
import { computed, reactive } from "vue";

const router = useRouter();
const route = useRoute();
const isParentRoute = !route.params.group_uid;

const state = reactive({
  search: "",
});

const filteredGroups = computed(() => {
  const s = state.search.toLowerCase();
  if (!groups.value) return [];
  if (!s) return groups.value;
  return groups.value.filter((group) => {
    const g =
      group.abv.toLowerCase() +
      group.name.toLowerCase() +
      group.unit_code?.toLowerCase();
    return g.includes(s);
  });
});

const {
  isLoading,
  isError,
  data: groups,
} = useQuery("get-all-groups", async () => {
  const res = await groupsGetGroups({});
  if (!res.ok) {
    throw new Error("Failed to get groups");
  }
  return res.data;
});
</script>

<template>
  <AppContainer>
    <template v-slot:header>
      <PageHeader
        description="Les groupes sont à la base de notre système d'accréditation."
        title="Groupes d'accréditation"
      />
    </template>
    <div v-if="isParentRoute">
      <div class="flex justify-center mb-3">
        <v-text-field
          v-if="
            state.search.length > 0 ||
            (filteredGroups && filteredGroups.length > 0)
          "
          v-model="state.search"
          append-inner-icon="mdi-magnify"
          hide-details
          label="Rechercher un groupe"
        ></v-text-field>
      </div>
      <div v-if="isLoading" class="flex justify-center">
        <v-progress-circular
          :size="74"
          :width="11"
          class="my-5"
          indeterminate
        ></v-progress-circular>
      </div>
      <div v-else-if="isError">
        <v-card :text="groups.error.message" title="Error" width="400"></v-card>
      </div>
      <div v-else class="">
        <div
          v-for="group in filteredGroups"
          v-bind:key="group.uid"
          class="my-3"
        >
          <GroupCard
            :abv="group.abv"
            :name="group.name"
            :unit="group.unit_code"
            @click="router.push(`/groups/${group.uid}`)"
          />
        </div>
      </div>
      <div
        v-if="!isLoading && (!filteredGroups || filteredGroups.length === 0)"
        class="my-3"
      >
        <v-card>
          <v-card-text>Aucun groupe trouvé</v-card-text>
        </v-card>
      </div>
    </div>
    <router-view></router-view>
  </AppContainer>
</template>
